unit Unit2;

interface

uses

  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, IpTypes, IpHlpApi,
  ActiveX,
  OpcLabs_BaseLib_TLB,
  OpcLabs_BaseLibForms_TLB,
  OpcLabs_EasyOpcClassic_TLB,
  OpcLabs_EasyOpcUA_TLB, Vcl.StdCtrls,
  ComObj;

type
  TGetNetwork = class(TThread)
  private
    list1: TStringlist;
  public
    constructor Create();
    Destructor Destroy; override;
    procedure Execute; override;
    procedure GetNetwork;
    procedure Ausgabe;
  end;

type
  TOPCThreadReader = class(TThread)
  private
  public
    ReadArguments: _UAReadArguments;
    Client: TEasyUAClient;
    URLSTRING: string;
    NodeID: string;
    constructor Create();
    Destructor Destroy; override;
    procedure Execute; override;
    procedure Read;
    procedure Ausgabe;
  end;

type
  TForm2 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Panel3: TPanel;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    Panel2: TPanel;
    Label1: TLabel;
    Button5: TButton;
    Button1: TButton;
    Label2: TLabel;
    NodID: TEdit;
    Label5: TLabel;
    Urlstring: TEdit;
    procedure Button5Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form2: TForm2;
  threadreader: TOPCThreadReader;
  threadgetnetwork: TGetNetwork;

  Rueckgabe: string;
  Rueckgabe1: string;
  Position_Read: byte;

implementation

{$R *.dfm}

procedure TGetNetwork.Ausgabe;
VAR
  i: integer;
begin
  Form2.Memo1.Lines.BeginUpdate;
  Form2.Memo1.Lines.clear;
  if list1.count > 0 then
  begin
    for i := 0 to list1.count - 1 do
      Form2.Memo1.Lines.add(list1.strings[i]);
  end;
  Form2.Memo1.Lines.EndUpdate;
    form2.Button3.Enabled := true;
end;

procedure TGetNetwork.GetNetwork;
var
  P: IUnknown;
  oEnum: IEnumvariant;
  iValue: LongWord;

  cnt: integer;
  f: cardinal;
  OutBufLen: ULONG;

  FSWbemLocator: OleVariant;
  FWMIService: OleVariant;

  NumInterfaces: cardinal;

  FWbemObjectSet: OleVariant;
  FWbemObject: OleVariant;
  AdapterInfo: array of TIpAdapterInfo;

  connected: integer;

  Instancename: string;
  aktiv: boolean;

begin;

  GetNumberOfInterfaces(NumInterfaces);

  OutBufLen := NumInterfaces * SizeOf(TIpAdapterInfo);
  try
    list1.clear;
    FSWbemLocator := CreateOleObject('WbemScripting.SWbemLocator');
    FWMIService := FSWbemLocator.ConnectServer('localhost', 'root\WMI', '', '');

    GetAdaptersInfo(@AdapterInfo[0], OutBufLen);
    try
      FWbemObject := FWMIService.InstancesOf('MSNdis_MediaConnectStatus');
      try
        P := FWbemObject._NewEnum;
        try
          P.QueryInterface(IEnumvariant, oEnum);
          if FWbemObject.count > 0 then
          begin
            for cnt := 0 to FWbemObject.count - 1 do
            begin
              try
                oEnum.Next(1, FWbemObjectSet, f);
                connected := FWbemObjectSet.NdisMediaConnectStatus;
                aktiv := FWbemObjectSet.Active;
                Instancename := FWbemObjectSet.Instancename;
                list1.add(Instancename);
              finally
                FWbemObjectSet := Unassigned;
              end;
            end;
          end;
        except

        end;
      finally
        FWbemObject := Unassigned;
        FSWbemLocator := Unassigned;
        FWMIService := Unassigned;
      end;
    except

    end;
  except

  end;
end;

constructor TGetNetwork.Create();
begin
  inherited Create;
  list1 := TStringlist.Create;
end;

destructor TGetNetwork.Destroy;
begin
  inherited Destroy;
  if list1 <> nil then
    freeandnil(list1);
  form2.Button2.Enabled := true;
end;

procedure TGetNetwork.Execute();
begin
  inherited;
  CoInitializeEX(nil, COINIT_Multithreaded);
  if (not terminated) then
  begin
    while not terminated do
    begin
      try
        sleep(10);
        GetNetwork;
        synchronize(Ausgabe);
      except

      end;
    end;
  end;

  CoUninitialize;
end;

procedure TOPCThreadReader.Ausgabe;
begin
  Form2.Panel1.caption := Rueckgabe;
  form2.Button1.Enabled := true;
end;

procedure TOPCThreadReader.Read;
VAR
  Results: OleVariant;
  WriteResult: _ValueResult;
  res: string;
  i: integer;
  Value: Variant;
  LBound: integer;
  HBound: integer;
  Arguments: OleVariant;
begin
  ReadArguments.EndpointDescriptor.UrlString := URLSTRING;

  ReadArguments.NodeDescriptor.NodeID.ExpandedText :=NODEID;

  Position_Read := 1;
  Arguments := VarArrayCreate([0, 0], varVariant);
  Arguments[0] := ReadArguments;

  Position_Read := 2;
  TVarData(Results).VType := vararray or varVariant;
  Position_Read := 3;
  TVarData(Results).VArray :=
    PVarArray(Client.readmultiplevalues(PSafeArray(TVarData(Arguments)
    .VArray)));
  Position_Read := 4;

  for i := VarArrayLowBound(Results, 1) to VarArrayHighBound(Results, 1) do
  begin
    WriteResult := IInterface(Results[i]) as _ValueResult;
    if WriteResult.Succeeded then
    begin
      Value := WriteResult.Value;
      Rueckgabe := formatfloat('0.000', Value);
      Position_Read := 5;
    end
    else
    begin
      res := ReadArguments.NodeDescriptor.NodeID.ExpandedText + ':' +
        WriteResult.Exception.GetBaseException.Message;
      Rueckgabe := res;
      Position_Read := 6;
    end;
  end;
  Varclear(Results);
  Varclear(Arguments);
end;

constructor TOPCThreadReader.Create();
begin
  inherited Create;
  if Client = nil then
  begin
    URLSTRING:=form2.Urlstring.Text;
    NodeID:=form2.NodID.text;
    ReadArguments := CoUAReadArguments.Create;
    Client := TEasyUAClient.Create(nil);
    Client.Connect;
  end;
end;

destructor TOPCThreadReader.Destroy;
begin
  inherited Destroy;
  if Client <> nil then
  begin
    Client.DisConnect;
    freeandnil(Client);
  end;
 form2.Button5.Enabled := true;
 form2.panel1.caption:='';
 form2.panel3.caption:='';

end;

procedure TOPCThreadReader.Execute();
VAR
  Error: string;
begin
  inherited;
  CoInitializeEX(nil, COINIT_Multithreaded);
  if (not terminated) then
  begin
    while not terminated do
    begin
      try
        sleep(10);
        try
          Read;
        except
          Error := 'Read';
        end;
        synchronize(Ausgabe);
      except

      end;
    end;
  end;

  CoUninitialize;
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if threadreader <> nil then
  begin
    threadreader.Terminate;
    freeandnil(threadreader);
    Button1.Enabled := false;
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if threadgetnetwork = nil then
  begin
    threadgetnetwork := TGetNetwork.Create;
    form2.Button2.Enabled := false;
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  if threadgetnetwork <> nil then
  begin
    threadgetnetwork.Terminate;
    freeandnil(threadgetnetwork);
    Button3.Enabled := false;
  end;

end;

procedure TForm2.Button5Click(Sender: TObject);
begin
  if threadreader = nil then
  begin
    threadreader := TOPCThreadReader.Create;
    Button5.Enabled := false;
  end;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin

  Timer1.Enabled := true;

end;

procedure TForm2.Timer1Timer(Sender: TObject);
begin
  Panel3.caption := inttostr(Position_Read);
  Panel2.caption := datetimetostr(now);
end;



end.
